XJOI 3363 树4/ Codeforces 739B Alyona and a tree(树上差分+路径倍增)

D. Alyona and a tree
time limit per test
 2 seconds
memory limit per test
 256 megabytes
input
 standard input
output
 standard output

Alyona has a tree with n vertices. The root of the tree is the vertex 1. In each vertex Alyona wrote an positive integer, in the vertex i she wrote ai. Moreover, the girl wrote a positive integer to every edge of the tree (possibly, different integers on different edges).

Let's define dist(v, u) as the sum of the integers written on the edges of the simple path from v to u.

The vertex v controls the vertex u (v ≠ u) if and only if u is in the subtree of v and dist(v, u) ≤ au.

Alyona wants to settle in some vertex. In order to do this, she wants to know for each vertex v what is the number of vertices u such that vcontrols u.

Input

The first line contains single integer n (1 ≤ n ≤ 2·105).

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ 109) — the integers written in the vertices.

The next (n - 1) lines contain two integers each. The i-th of these lines contains integers pi and wi (1 ≤ pi ≤ n1 ≤ wi ≤ 109) — the parent of the (i + 1)-th vertex in the tree and the number written on the edge between pi and (i + 1).

It is guaranteed that the given graph is a tree.

Output

Print n integers — the i-th of these numbers should be equal to the number of vertices that the i-th vertex controls.

Examples
input
5
2 5 1 4 6
1 7
1 1
3 5
3 6
output
1 0 1 0 0
input
5
9 7 8 6 5
1 1
2 1
3 1
4 1
output
4 3 2 1 0
Note

In the example test case the vertex 1 controls the vertex 3, the vertex 3 controls the vertex 5 (note that is doesn't mean the vertex 1controls the vertex 5).

题意:

给你一棵树,n个点, 以1为根,每个点有一个值,每条边有边权

我们规定假如u的子树中存在一个点v, 使得dist(u,v)<=a[v]dist(u,v)表示u 到 v的路径上的边权之和, a[v] 是v的点权

那么我们称u控制v

现在需要你算出每个点各控制了几个点

题解:

很显然被想到倍增统计路径和,然后你可以找到最远的那个被控制的点,然后该点到控制点的路径上全部加一,树上差分一下就行了

但是你A不了XJOI的,毕竟人家卡内存,所以还是去学所谓的树上二分吧,搬原题然后只改内存,这种素质我是第一次见。

代码如下:

#include<cstdio>
#include<vector>
#include<cstring>
#include<iostream>
#include<algorithm>
#define pii pair<int,int>
#define mp make_pair
#define int long long
using namespace std;
 
int n,a[200010],fa[19][240010],dis[19][240010],d[200010],ans[200010];
vector<pii> g[200010];
 
void dfs(int now,int f,int dist)
{
    fa[0][now]=f;
    dis[0][now]=dist;
    for(int i=1;i<=18;i++)
    {
        fa[i][now]=fa[i-1][fa[i-1][now]];
    }
    for(int i=1;i<=18;i++)
    {
        dis[i][now]=dis[i-1][now]+dis[i-1][fa[i-1][now]];
    }
    for(int i=0;i<g[now].size();i++)
    {
        if(g[now][i].first==f) continue;
        dfs(g[now][i].first,now,g[now][i].second); 
    }
}

int find(int x,int val)
{
    int pos=x,nowd=0;
    for(int i=18;i>=0;i--)
    {
        if(dis[i][pos]+nowd<=val&&fa[i][pos])
        {
            nowd+=dis[i][pos];
            pos=fa[i][pos];
        }
    }
    return pos;
}

void dfs2(int now,int f)
{
    int pos=find(now,a[now]);
    d[fa[0][pos]]--;
    d[fa[0][now]]++;
    for(int i=0;i<g[now].size();i++)
    {
        if(g[now][i].first==f) continue;
        dfs2(g[now][i].first,now);
    }
}

void dfs3(int now,int f)
{
    ans[now]=d[now];
    for(int i=0;i<g[now].size();i++)
    {
        if(f==g[now][i].first) continue;
        dfs3(g[now][i].first,now);
        ans[now]+=ans[g[now][i].first];
    }
}

signed main()
{
    scanf("%lld",&n);
    for(int i=1;i<=n;i++)
    {
        scanf("%lld",&a[i]);
    }
    for(int i=2;i<=n;i++)
    {
        int to,cost;
        scanf("%lld%lld",&to,&cost);
        g[to].push_back(mp(i,cost));
        g[i].push_back(mp(to,cost));
    }
    dfs(1,0,0);
    dfs2(1,0);
    dfs3(1,0);
    for(int i=1;i<=n;i++)
    {
        printf("%lld ",ans[i]);
    }
}
原文地址:https://www.cnblogs.com/stxy-ferryman/p/9324176.html